<?php
class BiblioDatabase
{
	var $engine = "mysql";
	var $host = "localhost";
	var $user = "root";
	var $password = "";
	
	var $dbName = "gydb_bibliography";
	
	var $db;
	
	function BiblioDatabase()
	{
		//constructor de la clase		
		$this->connect(); //crear la conexion con la base de datos
		$this->createDatabase(); //crear la base de datos si no existe		
	}
	
	
	function connect()
	{
		//conexion con la base de datos
		require_once ('adodb/adodb.inc.php');
		$dsn = $this->engine."://".$this->user.":".$this->password."@".$this->host."/".$this->dbName;
		$this->db = NewADOConnection($dsn);
		if (!$this->db) die("Connection failed");
		
		$this->db->debug = false;
		
		return $this->db;
	}
	
	function createDatabase()
	{
		$sql1 = 'CREATE DATABASE IF NOT EXISTS `gydb_bibliography`;';
		$sql2 = 'USE `gydb_bibliography`;';
		$sql3 = 'CREATE TABLE IF NOT EXISTS `reference` ('
        . ' `id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, '
		. ' `reftype` VARCHAR(2) NULL, ' 
        . ' `title` VARCHAR(255) NOT NULL, '
        . ' `authors` TEXT NOT NULL, '
        . ' `journal` VARCHAR(255) NULL, '
        . ' `publisher` VARCHAR(255) NULL, '
        . ' `date` DATE NOT NULL, '
        . ' `volume` VARCHAR(5) NULL, '
        . ' `pagestart` VARCHAR(5) NULL, '
        . ' `pageend` VARCHAR(5) NULL, '
        . ' `url` VARCHAR(255) NULL, '
        . ' `pmid` VARCHAR(30) NULL'
        . ' );';
		
		$rs = $this->db->Execute($sql1);		
		if ($rs === false)
		{
			die ("createDatabase(1):".$this->db->ErrorMsg());
		}
		$rs = $this->db->Execute($sql2);
		if ($rs === false)
		{
			die ("createDatabase(2):".$this->db->ErrorMsg());
		}
		$rs = $this->db->Execute($sql3);
		if ($rs === false)
		{
			die ("createDatabase(3):".$this->db->ErrorMsg());
		}
	}
	
	
	
	function referenceExists($authors, $title, $journal, $date)
	{
		$query = "SELECT `id` FROM `reference` WHERE ".
			"`authors`='".$authors."' AND ".
			"`title`='".$title."' AND ".
			"`journal`='".$journal."' AND ".
			"`date`=".$date;
		
		$rs = $this->db->GetCol($query);
		
		if ($rs === false)
		{
			die ("referenceExists():".$this->db->ErrorMsg());
		}
		
		if (count($rs) != 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	function saveReference($authors, $title, $date, $journal, $publisher, $volume, $pagestart, $pageend, $pmid, $url)
	{
		//recibe un array asociativo con los datos de la referencia bibliografica
		$query = "INSERT INTO `reference` (`authors`, `title`, `journal`, `publisher`, `date`, `volume`, `pagestart`, `pageend`, `pmid`, `url`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
		$args = array($authors, $title, $journal, $publisher, $date, $volume, $pagestart, $pageend, $pmid, $url);
		
		if ($this->referenceExists($authors, $title, $journal, $date)) return;
		
		$rs = $this->db->Execute($query, $args);
		
		if ($rs === false)
		{
			die ("saveReference():".$this->db->ErrorMsg());
		}
	}	
}
?>
